HashMultimap
Date: 2016-05-24

com.google.common.collect

## Class HashMultimap<K,V>

- java.lang.Object
- - com.google.common.collect.HashMultimap<K,V>

- All Implemented Interfaces:
    Multimap<K,V>, SetMultimap<K,V>, java.io.Serializable

      @GwtCompatible(serializable=true,
                     emulated=true)
      public final class HashMultimap<K,V>
      extends java.lang.Object

  Implementation of `Multimap` using hash tables.

  The multimap does not store duplicate key-value pairs. Adding a new key-value pair equal to an existing key-value pair has no effect.

  Keys and values may be null. All optional multimap methods are supported, and all returned views are modifiable.

  This class is not threadsafe when any concurrent operations update the multimap. Concurrent read operations will work correctly. To allow concurrent update operations, wrap your multimap with a call to `Multimaps.synchronizedSetMultimap(com.google.common.collect.SetMultimap<K, V>)`.

  Since:
    2.0
  See Also:
    Serialized Form

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.Map<K,java.util.Collection<V>>` | `asMap()` Returns a view of this multimap as a `Map` from each distinct key to the nonempty collection of that key's associated values.
    `void` | `clear()` Removes all key-value pairs from the multimap, leaving it empty.
    `boolean` | `containsEntry(java.lang.Object key, java.lang.Object value)` Returns `true` if this multimap contains at least one key-value pair with the key `key` and the value `value`.
    `boolean` | `containsKey(java.lang.Object key)` Returns `true` if this multimap contains at least one key-value pair with the key `key`.
    `boolean` | `containsValue(java.lang.Object value)` Returns `true` if this multimap contains at least one key-value pair with the value `value`.
    `static <K,V> HashMultimap<K,V>` | `create()` Creates a new, empty `HashMultimap` with the default initial capacities.
    `static <K,V> HashMultimap<K,V>` | `create(int expectedKeys, int expectedValuesPerKey)` Constructs an empty `HashMultimap` with enough capacity to hold the specified numbers of keys and values without rehashing.
    `static <K,V> HashMultimap<K,V>` | `create(Multimap<? extends K,? extends V> multimap)` Constructs a `HashMultimap` with the same mappings as the specified multimap.
    `java.util.Set<java.util.Map.Entry<K,V>>` | `entries()` Returns a view collection of all key-value pairs contained in this multimap, as `Map.Entry` instances.
    `boolean` | `equals(java.lang.Object object)` Compares the specified object to this multimap for equality.
    `java.util.Set<V>` | `get(K key)` Returns a view collection of the values associated with `key` in this multimap, if any.
    `int` | `hashCode()` Returns the hash code for this multimap.
    `boolean` | `isEmpty()` Returns `true` if this multimap contains no key-value pairs.
    `Multiset<K>` | `keys()` Returns a view collection containing the key from each key-value pair in this multimap, without collapsing duplicates.
    `java.util.Set<K>` | `keySet()` Returns a view collection of all distinct keys contained in this multimap.
    `boolean` | `put(K key, V value)` Stores a key-value pair in the multimap.
    `boolean` | `putAll(K key, java.lang.Iterable<? extends V> values)` Stores a key-value pair in this multimap for each of `values`, all using the same key, `key`.
    `boolean` | `putAll(Multimap<? extends K,? extends V> multimap)` Stores all key-value pairs of `multimap` in this multimap, in the order returned by `multimap.entries()`.
    `boolean` | `remove(java.lang.Object key, java.lang.Object value)` Removes a single key-value pair with the key `key` and the value `value` from this multimap, if such exists.
    `java.util.Set<V>` | `removeAll(java.lang.Object key)` Removes all values associated with the key `key`.
    `java.util.Set<V>` | `replaceValues(K key, java.lang.Iterable<? extends V> values)` Stores a collection of values with the same key, replacing any existing values for that key.
    `int` | `size()` Returns the number of key-value pairs in this multimap.
    `java.lang.String` | `toString()` Returns a string representation of the multimap, generated by calling `toString` on the map returned by `Multimap.asMap()`.
    `java.util.Collection<V>` | `values()` Returns a view collection containing the value from each key-value pair contained in this multimap, without collapsing duplicates (so `values().size() == size()`).

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.common.collect.Multimap

      `clear, containsEntry, containsKey, containsValue, hashCode, isEmpty, keys, keySet, putAll, putAll, remove, size, values`

- - ### Method Detail

    - #### create

          public static <K,V> HashMultimap<K,V> create()

      Creates a new, empty `HashMultimap` with the default initial capacities.

    - #### create

          public static <K,V> HashMultimap<K,V> create(int expectedKeys,
                                       int expectedValuesPerKey)

      Constructs an empty `HashMultimap` with enough capacity to hold the specified numbers of keys and values without rehashing.
      Parameters:
        `expectedKeys` - the expected number of distinct keys
        `expectedValuesPerKey` - the expected average number of values per key
      Throws:
        `java.lang.IllegalArgumentException` - if `expectedKeys` or `expectedValuesPerKey` is negative

    - #### create

          public static <K,V> HashMultimap<K,V> create(Multimap<? extends K,? extends V> multimap)

      Constructs a `HashMultimap` with the same mappings as the specified multimap. If a key-value mapping appears multiple times in the input multimap, it only appears once in the constructed multimap.
      Parameters:
        `multimap` - the multimap whose contents are copied to this multimap

    - #### get

          public java.util.Set<V> get(@Nullable
                             K key)

      Returns a view collection of the values associated with `key` in this multimap, if any. Note that when `containsKey(key)` is false, this returns an empty collection, not `null`.

      Changes to the returned collection will update the underlying multimap, and vice versa.

      The returned collection is not serializable.

      Because a `SetMultimap` has unique values for a given key, this method returns a `Set`, instead of the `Collection` specified in the `Multimap` interface.

      Specified by:
        `get` in interface `Multimap<K,V>`
      Specified by:
        `get` in interface `SetMultimap<K,V>`

    - #### entries

          public java.util.Set<java.util.Map.Entry<K,V>> entries()

      Returns a view collection of all key-value pairs contained in this multimap, as `Map.Entry` instances.

      Changes to the returned collection or the entries it contains will update the underlying multimap, and vice versa. However, adding to the returned collection is not possible.

      The iterator generated by the returned collection traverses the values for one key, followed by the values of a second key, and so on.

      Each entry is an immutable snapshot of a key-value mapping in the multimap, taken at the time the entry is returned by a method call to the collection or its iterator.

      Because a `SetMultimap` has unique values for a given key, this method returns a `Set`, instead of the `Collection` specified in the `Multimap` interface.

      Specified by:
        `entries` in interface `Multimap<K,V>`
      Specified by:
        `entries` in interface `SetMultimap<K,V>`

    - #### removeAll

          public java.util.Set<V> removeAll(@Nullable
                                   java.lang.Object key)

      Removes all values associated with the key `key`.

      Once this method returns, `key` will not be mapped to any values, so it will not appear in `Multimap.keySet()`, `Multimap.asMap()`, or any other views.

      The returned collection is immutable.

      Because a `SetMultimap` has unique values for a given key, this method returns a `Set`, instead of the `Collection` specified in the `Multimap` interface.

      Specified by:
        `removeAll` in interface `Multimap<K,V>`
      Specified by:
        `removeAll` in interface `SetMultimap<K,V>`
      Returns:
        the values that were removed (possibly empty). The returned collection may be modifiable, but updating it will have no effect on the multimap.

    - #### replaceValues

          public java.util.Set<V> replaceValues(@Nullable
                                       K key,
                                       java.lang.Iterable<? extends V> values)

      Stores a collection of values with the same key, replacing any existing values for that key.

      If `values` is empty, this is equivalent to `removeAll(key)`.

      The returned collection is immutable.

      Because a `SetMultimap` has unique values for a given key, this method returns a `Set`, instead of the `Collection` specified in the `Multimap` interface.

      Any duplicates in `values` will be stored in the multimap once.

      Specified by:
        `replaceValues` in interface `Multimap<K,V>`
      Specified by:
        `replaceValues` in interface `SetMultimap<K,V>`
      Returns:
        the collection of replaced values, or an empty collection if no values were previously associated with the key. The collection may be modifiable, but updating it will have no effect on the multimap.

    - #### asMap

          public java.util.Map<K,java.util.Collection<V>> asMap()

      Returns a view of this multimap as a `Map` from each distinct key to the nonempty collection of that key's associated values. Note that `this.asMap().get(k)` is equivalent to `this.get(k)` only when `k` is a key contained in the multimap; otherwise it returns `null` as opposed to an empty collection.

      Changes to the returned map or the collections that serve as its values will update the underlying multimap, and vice versa. The map does not support `put` or `putAll`, nor do its entries support `setValue`.

      Though the method signature doesn't say so explicitly, the returned map has `Set` values.

      Specified by:
        `asMap` in interface `Multimap<K,V>`
      Specified by:
        `asMap` in interface `SetMultimap<K,V>`

    - #### put

          public boolean put(@Nullable
                    K key,
                    @Nullable
                    V value)

      Stores a key-value pair in the multimap.
      Specified by:
        `put` in interface `Multimap<K,V>`
      Parameters:
        `key` - key to store in the multimap
        `value` - value to store in the multimap
      Returns:
        `true` if the method increased the size of the multimap, or `false` if the multimap already contained the key-value pair

    - #### equals

          public boolean equals(@Nullable
                       java.lang.Object object)

      Compares the specified object to this multimap for equality.

      Two `SetMultimap` instances are equal if, for each key, they contain the same values. Equality does not depend on the ordering of keys or values.

      Specified by:
        `equals` in interface `Multimap<K,V>`
      Specified by:
        `equals` in interface `SetMultimap<K,V>`

    - #### size

          public int size()

      Description copied from interface: `Multimap`
      Returns the number of key-value pairs in this multimap.

      Note: this method does not return the number of distinct keys in the multimap, which is given by `keySet().size()` or `asMap().size()`. See the opening section of the `Multimap` class documentation for clarification.

      Specified by:
        `size` in interface `Multimap<K,V>`

    - #### containsKey

          public boolean containsKey(@Nullable
                            java.lang.Object key)

      Description copied from interface: `Multimap`
      Returns `true` if this multimap contains at least one key-value pair with the key `key`.
      Specified by:
        `containsKey` in interface `Multimap<K,V>`

    - #### clear

          public void clear()

      Description copied from interface: `Multimap`
      Removes all key-value pairs from the multimap, leaving it empty.
      Specified by:
        `clear` in interface `Multimap<K,V>`

    - #### values

          public java.util.Collection<V> values()

      Returns a view collection containing the value from each key-value pair contained in this multimap, without collapsing duplicates (so `values().size() == size()`).

      Changes to the returned collection will update the underlying multimap, and vice versa. However, adding to the returned collection is not possible.

      The iterator generated by the returned collection traverses the values for one key, followed by the values of a second key, and so on.

      Specified by:
        `values` in interface `Multimap<K,V>`

    - #### isEmpty

          public boolean isEmpty()

      Description copied from interface: `Multimap`
      Returns `true` if this multimap contains no key-value pairs. Equivalent to `size() == 0`, but can in some cases be more efficient.
      Specified by:
        `isEmpty` in interface `Multimap<K,V>`

    - #### containsValue

          public boolean containsValue(@Nullable
                              java.lang.Object value)

      Description copied from interface: `Multimap`
      Returns `true` if this multimap contains at least one key-value pair with the value `value`.
      Specified by:
        `containsValue` in interface `Multimap<K,V>`

    - #### containsEntry

          public boolean containsEntry(@Nullable
                              java.lang.Object key,
                              @Nullable
                              java.lang.Object value)

      Description copied from interface: `Multimap`
      Returns `true` if this multimap contains at least one key-value pair with the key `key` and the value `value`.
      Specified by:
        `containsEntry` in interface `Multimap<K,V>`

    - #### remove

          public boolean remove(@Nullable
                       java.lang.Object key,
                       @Nullable
                       java.lang.Object value)

      Description copied from interface: `Multimap`
      Removes a single key-value pair with the key `key` and the value `value` from this multimap, if such exists. If multiple key-value pairs in the multimap fit this description, which one is removed is unspecified.
      Specified by:
        `remove` in interface `Multimap<K,V>`
      Returns:
        `true` if the multimap changed

    - #### putAll

          public boolean putAll(@Nullable
                       K key,
                       java.lang.Iterable<? extends V> values)

      Description copied from interface: `Multimap`
      Stores a key-value pair in this multimap for each of `values`, all using the same key, `key`. Equivalent to (but expected to be more efficient than):

             for (V value : values) {
               put(key, value);
             }

      In particular, this is a no-op if `values` is empty.

      Specified by:
        `putAll` in interface `Multimap<K,V>`
      Returns:
        `true` if the multimap changed

    - #### putAll

          public boolean putAll(Multimap<? extends K,? extends V> multimap)

      Description copied from interface: `Multimap`
      Stores all key-value pairs of `multimap` in this multimap, in the order returned by `multimap.entries()`.
      Specified by:
        `putAll` in interface `Multimap<K,V>`
      Returns:
        `true` if the multimap changed

    - #### keySet

          public java.util.Set<K> keySet()

      Description copied from interface: `Multimap`
      Returns a view collection of all distinct keys contained in this multimap. Note that the key set contains a key if and only if this multimap maps that key to at least one value.

      Changes to the returned set will update the underlying multimap, and vice versa. However, adding to the returned set is not possible.

      Specified by:
        `keySet` in interface `Multimap<K,V>`

    - #### keys

          public Multiset<K> keys()

      Description copied from interface: `Multimap`
      Returns a view collection containing the key from each key-value pair in this multimap, without collapsing duplicates. This collection has the same size as this multimap, and `keys().count(k) == get(k).size()` for all `k`.

      Changes to the returned multiset will update the underlying multimap, and vice versa. However, adding to the returned collection is not possible.

      Specified by:
        `keys` in interface `Multimap<K,V>`

    - #### hashCode

          public int hashCode()

      Returns the hash code for this multimap.

      The hash code of a multimap is defined as the hash code of the map view, as returned by `Multimap.asMap()`.

      Specified by:
        `hashCode` in interface `Multimap<K,V>`
      Overrides:
        `hashCode` in class `java.lang.Object`
      See Also:
        `Map.hashCode()`

    - #### toString

          public java.lang.String toString()

      Returns a string representation of the multimap, generated by calling `toString` on the map returned by `Multimap.asMap()`.
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        a string representation of the multimap